#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/shm.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <errno.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/wait.h>

#define HUGEPAGESIZE	2*1024*1024UL
#define MMAP_FILE	"/tmp/mmap/m1"

int i=0;

int mmap_open_mmap(int *fd, void **addr, size_t length, int prot, int flags)
{
        *fd = open(MMAP_FILE, O_CREAT|O_RDWR, 0755);
        if (*fd < 0) {
                perror("Open failed");
                exit(errno);
        }
        *addr = mmap(NULL, length, prot, flags, *fd, 0);
        if( *addr == (void *)-1 ) {
                perror("mmap failed");
		printf("loop i=%d\n", i);
		exit(-1);
                return -1;
        }

        return 0;
}


void test()
{
	int fd=-1;
	void *addr=0;
	int fd_tmp=-1;
	long i=0;
	//fd_tmp=open(FILE01, O_RDONLY);


	mmap_open_mmap(&fd, &addr, HUGEPAGESIZE, PROT_READ|PROT_WRITE, MAP_SHARED);
	printf("addr=%p\n", addr);
	//mmap_open_mmap(&fd, &addr, HUGEPAGESIZE, PROT_WRITE|PROT_READ, MAP_PRIVATE);
/*for(i=0;i<HUGEPAGESIZE;i++)
	{
		addr[i] = '9';
	}

	printf("Succeed!\n");
*/
	munmap(addr, HUGEPAGESIZE);
	close(fd);
	unlink(MMAP_FILE);
}

main()
{

	for(i=0; i<1000; i++)
	{
		test();
	}
}

